top.window.NATIVE_TO_JS = {};
top.window.NATIVE_TO_JS.trigger = function(command, content) {
  switch (command) {
    case "copy":
      paCustomCopy(getSelectionHtml());
      break;
    case "paste":
      paCustomPaste(content);
      break;
  }
};
var naive_ios_index = 1;
function paCustomPaste(value) {
  if (!document.activeElement || !value) return;
  if (
    document.activeElement &&
    ["INPUT", "TEXTAREA"].indexOf(document.activeElement.tagName) === -1
  )
    return;
  var textDom = document.activeElement;
  value = value.replace(/<br(\s)?\/>/gi, "\r\n");
  var selectRange;
  if (document.selection) {
    textDom.focus();
    selectRange = document.selection.createRange();
    selectRange.text = value;
    textDom.focus();
  } else if (textDom.selectionStart || textDom.selectionStart == "0") {
    var startPos = textDom.selectionStart;
    var endPos = textDom.selectionEnd;
    var scrollTop = textDom.scrollTop;
    textDom.value =
      textDom.value.substring(0, startPos) +
      value +
      textDom.value.substring(endPos, textDom.value.length);
    textDom.focus();
    textDom.selectionStart = startPos + value.length;
    textDom.selectionEnd = startPos + value.length;
    textDom.scrollTop = scrollTop;
  } else {
    textDom.value += value;
    textDom.focus();
  }
  if (value) fireEvent(textDom, "input");
}
function getSelectionHtml() {
  var html = "";
  if (typeof window.getSelection != "undefined") {
    html = window.getSelection().toString();
  } else if (typeof document.selection != "undefined") {
    if (document.selection.type == "Text") {
      html = document.selection.createRange().text;
    }
  }
  return html;
}
function fireEvent(node, eventName) {
  var doc;
  if (node.ownerDocument) {
    doc = node.ownerDocument;
  } else if (node.nodeType == 9) {
    doc = node;
  } else {
    throw new Error("Invalid node passed to fireEvent: " + node.id);
  }
  if (node.dispatchEvent) {
    var eventClass = "";
    switch (eventName) {
      case "click":
      case "mousedown":
      case "mouseup":
        eventClass = "MouseEvents";
        break;
      case "focus":
      case "change":
      case "blur":
      case "select":
      case "input":
        eventClass = "HTMLEvents";
        break;

      default:
        throw "fireEvent: Couldn't find an event class for event '" +
          eventName +
          "'.";
        break;
    }
    var event = doc.createEvent(eventClass);
    event.initEvent(eventName, true, true);

    event.synthetic = true;
    node.dispatchEvent(event, true);
  } else if (node.fireEvent) {
    var event = doc.createEventObject();
    event.synthetic = true;
    node.fireEvent("on" + eventName, event);
  }
}
function paCustomCopy(content) {
  var ua = navigator.userAgent;
  var cb = function() {};
  if (/(IPHONE|IPAD)/gi.test(ua)) {
    window[naive_ios_index] = cb;
    var iframe = document.createElement("iframe");
    iframe.src = "#ios:paCustomCopy|" + content + "|" + naive_ios_index;
    iframe.style.display = "none";
    document.body.appendChild(iframe);
    setTimeout(function() {
      document.body.removeChild(iframe);
    }, 300);
  }
  if (/ANDROID/gi.test(ua)) {
    window["_cb_" + naive_ios_index] = cb;
    window.android.paCustomCopy(content, "_cb_" + naive_ios_index);
  }
  naive_ios_index++;
}
